Bug 486215 - [IPV6] Check outgoing interface even if source address is unspecified
[IPV6] Check outgoing interface even if source address is unspecified
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
medium Severity medium
: rc
: ---
Assigned To: Jiri Pirko
Red Hat Kernel QE team
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-18 16:42 EST by Dave Maley
Modified: 2015-05-04 21:16 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 04:49:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
reproducer (2.04 KB, text/plain)
2009-02-18 16:44 EST, Dave Maley
no flags Details
patch provided by partner (1.97 KB, patch)
2009-02-18 16:44 EST, Dave Maley
no flags Details | Diff

  None (edit)
Description Dave Maley 2009-02-18 16:42:08 EST
Description of problem:
IPV6/UDP: Kernel returns 0 when use sendmsg() to send a message with non-exist outgoing interface as ancillary data.  Kernel should return an error 'ENODEV'.


Version-Release number of selected component (if applicable):
kernel-2.6.18-128.EL


How reproducible:
every time


Steps to Reproduce:
(see attached reproducer)
1. # gcc -o pktinfo-3 pktinfo-3.c
2. # ./pktinfo-3

  
Actual results:
Kernel returns 0

Reproduce program log.
# ./pktinfo-3
== create an IPv6/UDP socket ==
== bind socket to address ==
== send message on non-exist interface ==
kernel return errno: 0
ERROR: Kernel success to send a message when specifying a non-exist outgoing interface as ancillary data
<=====NG=====>


Expected results:
Kernel returns an error 'ENODEV'


Additional info:
The reproduction program:
  pktinfo-3.c

The patch file is attached:
  file: net-fix-return-value-when-sendmsg-through-non-exist-interface.patch

This patch has already been applied for the Community's kernel.
Comment 1 Dave Maley 2009-02-18 16:44:11 EST
Created attachment 332456 [details]
reproducer

# gcc -o pktinfo-3 pktinfo-3.c
# ./pktinfo-3
Comment 2 Dave Maley 2009-02-18 16:44:55 EST
Created attachment 332457 [details]
patch provided by partner

upstream info:
commit 187e38384c4abfbbb1b880fab234d16c2df23a25
Author: YOSHIFUJI Hideaki <yoshfuji@linux-ipv6.org>
Date:   Wed Jun 4 13:01:37 2008 +0900
Comment 4 Don Zickus 2009-03-16 11:22:20 EDT
in kernel-2.6.18-135.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 7 Chris Ward 2009-07-03 14:25:09 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 8 Chris Ward 2009-07-10 15:11:15 EDT
~~ Attention Partners - RHEL 5.4 Snapshot 1 Released! ~~

RHEL 5.4 Snapshot 1 has been released on partners.redhat.com. If you have already reported your test results, you can safely ignore this request. Otherwise, please notice that there should be a fix available now that addresses this particular request. Please test and report back your results here, at your earliest convenience. The RHEL 5.4 exception freeze is quickly approaching.

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Do not flip the bug status to VERIFIED. Instead, please set your Partner ID in the Verified field above if you have successfully verified the resolution of this issue. 

Further questions can be directed to your Red Hat Partner Manager or other appropriate customer representative.
Comment 11 errata-xmlrpc 2009-09-02 04:49:25 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.